Gecode::Int::ViewValGraph::Node< View > Class Template Reference

Base-class for nodes (both view and value nodes). More...

`#include <view-val-graph.hh>`

## Public Member Functions

| Node (void)
| Initialize.
Edge< View > * | edge_fst (void) const
| Return first edge (organized by bi-links).
Edge< View > * | edge_lst (void) const
| Return last edge (organized by bi-links).
Public Member Functions inherited from Gecode::Int::ViewValGraph::BiLink
| BiLink (void)
| Initialize as empty (self referenced).
BiLink * | prev (void) const
| Return previous element.
BiLink * | next (void) const
| Return next element.
void | prev (BiLink *l)
| Set previous element to l.
void | next (BiLink *l)
| Set next element to l.
void | add (BiLink *l)
| Add l after this element.
void | unlink (void)
| Unlink this element.
void | mark (void)
| Mark element (invalidates next element pointer).
bool | marked (void) const
| Whether element is marked.
bool | empty (void) const
| Whether element has no previous and next element.

## Static Public Member Functions

static void * | operator new (size_t, Space &)
| Allocate memory from space.
static void | operator delete (void *, size_t)
| Needed for exceptions.
static void | operator delete (void *, Space &)
| Needed for exceptions.

## Public Attributes

Edge< View > * | iter
| Next edge for computing strongly connected components.
unsigned int | low
| Values for computing strongly connected components.
unsigned int | min
unsigned int | comp

## Detailed Description

template<class View>
class Gecode::Int::ViewValGraph::Node< View >

Base-class for nodes (both view and value nodes).

Note: the obvious ill-design to have also nodes and edges parametric wrt View is because the right design (having template function members) gets miscompiled (and actually not even compiled with some C++ compilers). Duh!

Definition at line 116 of file view-val-graph.hh.

## Constructor & Destructor Documentation

## Node()

template<class View>

Gecode::Int::ViewValGraph::Node< View >::Node | ( | void |  | ) |

inline

Initialize.

Definition at line 43 of file node.hpp.

## Member Function Documentation

## edge_fst()

template<class View>

Edge< View > * Gecode::Int::ViewValGraph::Node< View >::edge_fst | ( | void |  | ) | const

inline

Return first edge (organized by bi-links).

Definition at line 48 of file node.hpp.

## edge_lst()

template<class View>

Edge< View > * Gecode::Int::ViewValGraph::Node< View >::edge_lst | ( | void |  | ) | const

inline

Return last edge (organized by bi-links).

Definition at line 53 of file node.hpp.

## operator new()

template<class View>

void * Gecode::Int::ViewValGraph::Node< View >::operator new | ( | size_t | s,
|  | Space & | home )

inline static

Allocate memory from space.

Definition at line 64 of file node.hpp.

## operator delete() [1/2]

template<class View>

void Gecode::Int::ViewValGraph::Node< View >::operator delete | ( | void * | ,
|  | size_t | )

inline static

Needed for exceptions.

Definition at line 58 of file node.hpp.

## operator delete() [2/2]

template<class View>

void Gecode::Int::ViewValGraph::Node< View >::operator delete | ( | void * | ,
|  | Space & | )

inline static

Needed for exceptions.

Definition at line 61 of file node.hpp.

## Member Data Documentation

## iter

template<class View>

Edge<View>* Gecode::Int::ViewValGraph::Node< View >::iter

Next edge for computing strongly connected components.

Definition at line 119 of file view-val-graph.hh.

## low

template<class View>

unsigned int Gecode::Int::ViewValGraph::Node< View >::low

Values for computing strongly connected components.

Definition at line 121 of file view-val-graph.hh.

## min

template<class View>

unsigned int Gecode::Int::ViewValGraph::Node< View >::min

Definition at line 121 of file view-val-graph.hh.

## comp

template<class View>

unsigned int Gecode::Int::ViewValGraph::Node< View >::comp

Definition at line 121 of file view-val-graph.hh.

The documentation for this class was generated from the following files:

- gecode/int/view-val-graph.hh
- gecode/int/view-val-graph/node.hpp